//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//|                                             SpeedOmeter PRO.mq4 |
//|                      Copyright  2014, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#property copyright "SpeedOmeter PRO"
#property link      "http://www.eaprogramming.co.cc"
#property strict
#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_level1 0.5
#property indicator_level2 1.0
#property indicator_level3 1.5
#property indicator_level4 2.0
#property indicator_level5 2.5
#property indicator_level6 3.0

extern int NumberOfTicks = 10;
extern bool ShowPlusData = TRUE;
extern int DrawTicks = 1000;
extern bool MeterOnChart = TRUE;
extern color outcolor = Red;
extern color incolor = Black;
extern color arrowcolor = DodgerBlue;
extern color textcolor = Red;
extern color valuecolor = Red;
extern color scalecolor = CornflowerBlue;
double Gda_116[];
int Gi_120 = 0;
double Gd_124;
double Gd_132;
double Gd_140;
double Gda_unused_148[];
double Gda_unused_152[];
double Gd_156;
double Gd_164;
double G_ibuf_172[];
int G_bars_176;
double Gd_180;
double G_datetime_188;
bool Gi_196 = TRUE;
int G_window_200 = 0;
bool Gi_204 = TRUE;

int init() {
   if (MeterOnChart == TRUE) G_window_200 = 0;
   else G_window_200 = 1;
   ArrayResize(Gda_116, NumberOfTicks);
   Gda_116[0] = TimeCurrent();
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, G_ibuf_172);
   IndicatorShortName("speedOmeter PRO");
   for (int Li_0 = Bars - 1; Li_0 >= 0; Li_0--) G_ibuf_172[Li_0] = 0.0;
   return (0);
}

int deinit() {
   ObjectDelete("jarrow");
   ObjectDelete("ertek");
   ObjectDelete("lfel");
   ObjectDelete("lfel1");
   ObjectDelete("lfel2");
   ObjectDelete("lfel3");
   ObjectDelete("lfel4");
   ObjectDelete("lfel5");
   ObjectDelete("lfel6");
   ObjectDelete("koz0");
   ObjectDelete("koz1");
   ObjectDelete("szov0");
   ObjectDelete("szov1");
   ObjectDelete("szov2");
   ObjectDelete("szov3");
   ObjectDelete("kor0");
   ObjectDelete("kor1");
   ObjectDelete("kor2");
   ObjectDelete("kor3");
   ObjectDelete("korq0");
   ObjectDelete("korq1");
   ObjectDelete("korq2");
   ObjectDelete("korq3");
   ObjectDelete("load0");
   ObjectDelete("load1");
   ObjectDelete("load2");
   ObjectDelete("load3");
   ObjectDelete("load4");
   ObjectDelete("load5");
   ObjectDelete("rema0");
   ObjectDelete("rema1");
   ObjectDelete("rema2");
   ObjectDelete("rema3");
   ObjectDelete("rema4");
   ObjectDelete("rema5");
   ObjectDelete("tps");
   return (0);
}

int start() {
   string Ls_12;
   int Li_28;
   if (Gi_120 == NumberOfTicks) {
      ShiftArrays();
      Gi_120 = NumberOfTicks - 1;
   }
   if (Gi_196 == TRUE) {
      G_datetime_188 = TimeCurrent();
      Gi_196 = FALSE;
   }
   if (NumberOfTicks - Gi_120 == 1 && Gi_204 == TRUE) {
      for (int count_0 = 0; count_0 < 3; count_0++) objectCreate2("kor" + count_0, 0.8 * count_0 + 50.0, count_0 + 30, outcolor - 100 - 42 * count_0, "e", 80 - count_0);
      for (int count_4 = 0; count_4 < 3; count_4++) objectCreate2("korq" + count_4, 50 - 0.8 * count_4, 30 - 1 * count_4, outcolor - count_4 * 4 - 42 * count_4, "e", count_4 + 80);
      for (int count_8 = 0; count_8 < 3; count_8++) objectCreate4("szov" + count_8, 0.8 * count_8 + 68.0, 0.8 * count_8 + 200.0, textcolor, "speedOmeter", 10);
      objectCreate2("koz0", 24, 34, arrowcolor, "r", 80);
      objectCreate2("koz1", 24, 34, incolor, "s", 80);
      objectCreate3("lfel", 150, 145, scalecolor, "0.0", 10);
      objectCreate3("lfel1", 59, 145, scalecolor, "3.0", 10);
      objectCreate3("lfel2", 40, 105, scalecolor, "2.5", 8);
      objectCreate3("lfel3", 170, 105, scalecolor, "0.5", 8);
      objectCreate3("lfel4", 150, 55, scalecolor, "1.0", 10);
      objectCreate3("lfel5", 59, 55, scalecolor, "2.0", 10);
      objectCreate3("lfel6", 105, 38, scalecolor, "1.5", 8);
      objectCreate3("tps", 104, 170, scalecolor, "T/S", 8);
      Gi_204 = FALSE;
   }
   Gda_116[Gi_120] = TimeCurrent();
   Gd_124 = 1 / ((Gda_116[NumberOfTicks - 1] - Gda_116[0]) / NumberOfTicks);
   Gd_156 = Gda_116[NumberOfTicks - 1] - G_datetime_188;
   Gd_140 = NormalizeDouble(Gd_124, 1);
   if (Gd_124 > Gd_132) Gd_132 = Gd_124;
   else Gd_132 = Gd_132;
   if (ShowPlusData == TRUE && NumberOfTicks - Gi_120 == 1) {
      Ls_12 = "" 
         + "\n" 
         + "" 
         + "\n" 
         + "speedOmeter" 
         + "\n" 
         + "" 
         + "\n" 
         + "ticks collected since running = " + DoubleToStr(Gd_180, 0) 
         + "\n" 
         + "" 
         + "\n" 
         + "elapsed seconds since running = " + DoubleToStr(Gd_156, 0) 
         + "\n" 
         + "" 
         + "\n" 
         + "maximum speed since running = " + DoubleToStr(NormalizeDouble(Gd_132, 2), 2) + " Ticks/Second" 
         + "\n" 
         + "" 
         + "\n" 
      + "average speed since running = " + DoubleToStr(Gd_164, 2) + " Ticks/Second";
      Comment(Ls_12);
   }
   if (NumberOfTicks - Gi_120 != 1) {
      for (int count_20 = 0; count_20 < 4; count_20++) objectCreate5("load" + count_20, count_20 / 2.0 + 150.0, 0.8 * count_20 + 20.0, textcolor - 22 * count_20, "Loading Ticks, please wait...", 20);
      for (int count_24 = 0; count_24 < 4; count_24++) objectCreate5("rema" + count_24, count_24 / 2.0 + 150.0, 0.8 * count_24 + 60.0, textcolor - 22 * count_24, "Ticks remaining: " + ((NumberOfTicks - Gi_120 - 1)), 20);
   } else {
      ObjectDelete("load0");
      ObjectDelete("load1");
      ObjectDelete("load2");
      ObjectDelete("load3");
      ObjectDelete("load4");
      ObjectDelete("load5");
      ObjectDelete("rema0");
      ObjectDelete("rema1");
      ObjectDelete("rema2");
      ObjectDelete("rema3");
      ObjectDelete("rema4");
      ObjectDelete("rema5");
      if (Gd_140 == 0.0) objectCreate2("jarrow", 45, 50, arrowcolor, "0", 60);
      if (Gd_140 == 0.1) objectCreate2("jarrow", 45, 50, arrowcolor, "1", 60);
      if (Gd_140 == 0.2) objectCreate2("jarrow", 45, 50, arrowcolor, "2", 60);
      if (Gd_140 == 0.3) objectCreate2("jarrow", 45, 50, arrowcolor, "3", 60);
      if (Gd_140 == 0.4) objectCreate2("jarrow", 45, 50, arrowcolor, "4", 60);
      if (Gd_140 == 0.5) objectCreate2("jarrow", 45, 50, arrowcolor, "5", 60);
      if (Gd_140 == 0.6) objectCreate2("jarrow", 45, 50, arrowcolor, "6", 60);
      if (Gd_140 == 0.7) objectCreate2("jarrow", 45, 50, arrowcolor, "7", 60);
      if (Gd_140 == 0.8) objectCreate2("jarrow", 45, 50, arrowcolor, "8", 60);
      if (Gd_140 == 0.9) objectCreate2("jarrow", 45, 50, arrowcolor, "9", 60);
      if (Gd_140 == 1.0) objectCreate2("jarrow", 45, 50, arrowcolor, "A", 60);
      if (Gd_140 == 1.1) objectCreate2("jarrow", 45, 50, arrowcolor, "B", 60);
      if (Gd_140 == 1.2) objectCreate2("jarrow", 45, 50, arrowcolor, "C", 60);
      if (Gd_140 == 1.3) objectCreate2("jarrow", 45, 50, arrowcolor, "D", 60);
      if (Gd_140 == 1.4) objectCreate2("jarrow", 45, 50, arrowcolor, "E", 60);
      if (Gd_140 == 1.5) objectCreate2("jarrow", 45, 50, arrowcolor, "F", 60);
      if (Gd_140 == 1.6) objectCreate2("jarrow", 45, 50, arrowcolor, "G", 60);
      if (Gd_140 == 1.7) objectCreate2("jarrow", 45, 50, arrowcolor, "H", 60);
      if (Gd_140 == 1.8) objectCreate2("jarrow", 45, 50, arrowcolor, "I", 60);
      if (Gd_140 == 1.9) objectCreate2("jarrow", 45, 50, arrowcolor, "J", 60);
      if (Gd_140 == 2.0) objectCreate2("jarrow", 45, 50, arrowcolor, "K", 60);
      if (Gd_140 == 2.1) objectCreate2("jarrow", 45, 50, arrowcolor, "L", 60);
      if (Gd_140 == 2.2) objectCreate2("jarrow", 45, 50, arrowcolor, "M", 60);
      if (Gd_140 == 2.3) objectCreate2("jarrow", 45, 50, arrowcolor, "N", 60);
      if (Gd_140 == 2.4) objectCreate2("jarrow", 45, 50, arrowcolor, "O", 60);
      if (Gd_140 == 2.5) objectCreate2("jarrow", 45, 50, arrowcolor, "P", 60);
      if (Gd_140 == 2.6) objectCreate2("jarrow", 45, 50, arrowcolor, "Q", 60);
      if (Gd_140 == 2.7) objectCreate2("jarrow", 45, 50, arrowcolor, "R", 60);
      if (Gd_140 == 2.8) objectCreate2("jarrow", 45, 50, arrowcolor, "S", 60);
      if (Gd_140 == 2.9) objectCreate2("jarrow", 45, 50, arrowcolor, "T", 60);
      if (Gd_140 >= 3.0) objectCreate2("jarrow", 45, 50, arrowcolor, "U", 60);
      Gd_164 = 1 / (Gd_156 / Gd_180);
      Li_28 = 100;
      objectCreate3("ertek", Li_28, 150, valuecolor, DoubleToStr(Gd_140, 1), 14);
   }
   Gi_120++;
   if (NewBar()) {
      Gd_180++;
      G_ibuf_172[0] = Gd_124;
   } else {
      Gd_180++;
      ShiftArray();
      G_ibuf_172[0] = Gd_124;
   }
   return (0);
}

void objectCreate2(string A_name_0, int A_x_8, int A_y_12, color A_color_16, string A_text_20, int A_fontsize_28, string A_fontname_32 = "speedOmeter") {
   ObjectCreate(A_name_0, OBJ_LABEL, G_window_200, 0, 0);
   ObjectSet(A_name_0, OBJPROP_CORNER, 1);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
   ObjectSet(A_name_0, OBJPROP_XDISTANCE, A_x_8);
   ObjectSet(A_name_0, OBJPROP_YDISTANCE, A_y_12);
   ObjectSetText(A_name_0, A_text_20, A_fontsize_28, A_fontname_32, A_color_16);
}

void objectCreate3(string A_name_0, int A_x_8, int A_y_12, color A_color_16, string A_text_20, int A_fontsize_28, string A_fontname_32 = "Arial") {
   ObjectCreate(A_name_0, OBJ_LABEL, G_window_200, 0, 0);
   ObjectSet(A_name_0, OBJPROP_CORNER, 1);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
   ObjectSet(A_name_0, OBJPROP_XDISTANCE, A_x_8);
   ObjectSet(A_name_0, OBJPROP_YDISTANCE, A_y_12);
   ObjectSetText(A_name_0, A_text_20, A_fontsize_28, A_fontname_32, A_color_16);
}

void objectCreate4(string A_name_0, int A_x_8, int A_y_12, color A_color_16, string A_text_20, int A_fontsize_28, string A_fontname_32 = "Arial") {
   ObjectCreate(A_name_0, OBJ_LABEL, G_window_200, 0, 0);
   ObjectSet(A_name_0, OBJPROP_CORNER, 1);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
   ObjectSet(A_name_0, OBJPROP_XDISTANCE, A_x_8);
   ObjectSet(A_name_0, OBJPROP_YDISTANCE, A_y_12);
   ObjectSetText(A_name_0, A_text_20, A_fontsize_28, A_fontname_32, A_color_16);
}

void objectCreate5(string A_name_0, int A_x_8, int A_y_12, color A_color_16, string A_text_20, int A_fontsize_28, string A_fontname_32 = "Arial") {
   ObjectCreate(A_name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSet(A_name_0, OBJPROP_CORNER, 0);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
   ObjectSet(A_name_0, OBJPROP_XDISTANCE, A_x_8);
   ObjectSet(A_name_0, OBJPROP_YDISTANCE, A_y_12);
   ObjectSetText(A_name_0, A_text_20, A_fontsize_28, A_fontname_32, A_color_16);
}

void ShiftArrays() {
   for (int index_0 = 0; index_0 < NumberOfTicks - 1; index_0++) Gda_116[index_0] = Gda_116[index_0 + 1];
}

void ShiftArray() {
   if (Gd_180 > 2 * DrawTicks) {
      for (int Li_0 = Gd_180; Li_0 >= DrawTicks; Li_0--) G_ibuf_172[Li_0] = 0.0;
      Gd_180 = DrawTicks;
   }
   for (int Li_4 = Gd_180; Li_4 > 0; Li_4--) G_ibuf_172[Li_4] = G_ibuf_172[Li_4 - 1];
}

int NewBar() {
   bool Li_ret_0 = FALSE;
   if (G_bars_176 != Bars) {
      Li_ret_0 = TRUE;
      G_bars_176 = Bars;
   }
   return (Li_ret_0);
}
